/**
 * This file is part of the SIASAR package.
 *
 * Next.js version 11.1.4
 *
 * SIASAR Global is a joint initiative launched by the governments of Honduras,
 * Nicaragua and Panama that soon expanded to other regions. The strategic
 * purpose of this initiative is to have a basic, updated and comparable
 * information tool on the rural water supply and sanitation services in place
 * in a given country.
 *
 * @summary SIASAR_3 Front-end
 *
 * @license GPL-3.0
 *
 * @see     http://globalsiasar.org/es/contact
 */
import React, {SyntheticEvent} from "react";
import {dmIsOfflineMode, dmSetOfflineMode} from "@/utils/dataManager/Offline";
import t from "@/utils/i18n";
import {smGetSession, smHasPermission, smHaveSession, smIsLoading, smSetSession} from "@/utils/sessionManager";
import Modal from "@/components/common/Modal";
import {FontAwesomeIcon} from "@fortawesome/react-fontawesome";
import {faCancel, faLink, faUnlink} from '@fortawesome/free-solid-svg-icons'
import router from "next/router";
import LinearProgressWithLabel from "@/components/common/LinearProgressWithLabel";
import {loadStateStep} from "@/objects/loadStateStep";
import {
    dmGetAllAdministrativeDivisions,
    dmGetCommunityServices,
    dmGetCurrencies,
    dmGetDefaultDiameters,
    dmGetDisinfectingSubstances,
    dmGetDistributionMaterials,
    dmGetEthnicities,
    dmGetFunctionsCarriedOutTaps,
    dmGetFunctionsCarriedOutWsps,
    dmGetFunderInterventions,
    dmGetGeographicalScope,
    dmGetInstitutionInterventions,
    dmGetInterventionStatuses,
    dmGetMaterials,
    dmGetOfficialLanguages,
    dmGetProgramInterventions,
    dmGetPumpTypes,
    dmGetSpecialComponents,
    dmGetTechnicalAssistanceProviders,
    dmGetTreatmentTechnologyAerationOxidation,
    dmGetTreatmentTechnologyCoagFloccus,
    dmGetTreatmentTechnologyDesalination,
    dmGetTreatmentTechnologyFiltration,
    dmGetTreatmentTechnologySedimentations,
    dmGetTypeHealthcareFacilities,
    dmGetTypeInterventions,
    dmGetTypeTaps,
    dmGetTypologyChlorinationInstallations,
    dmGetWaterQualityEntities,
    dmGetWaterQualityInterventionTypes
} from "@/utils/dataManager/ParametricRead";
import QueueProcessor from "@/utils/QueueProcessor";
import {
    dmGetCountries,
    dmGetEmptyFormRecord,
    dmGetFileContent,
    dmGetFileName,
    dmGetFileUrl,
    dmGetFormRecord,
    dmGetFormStructure,
    dmGetFormTypes,
    dmGetInquires,
    dmGetPoint,
    dmGetPointInquiries,
    dmGetPoints,
    dmGetSafeUsers,
    dmGetUsers,
    dmLoadImage
} from "@/utils/dataManager";
import {User} from "@/objects/User";
import {db} from "@/utils/db";
import {DynFormRecordInterface} from "@/objects/DynForm/DynFormRecordInterface";
import {DynFormStructureInterface} from "@/objects/DynForm/DynFormStructureInterface";
import {DynFormStructureFieldInterface} from "@/objects/DynForm/DynFormStructureFieldInterface";
import {dmGetHouseholdProcesses, dmGetUserHouseholds} from "@/utils/dataManager/Household";
import {dmInvalidateAllAdministrativeDivisions} from "@/utils/dataManager/ParametricWrite";
import JSZip from "jszip";
import offlineDataRepository, {OfflineItemInterface} from "@/utils/offlineDataRepository";
import {empty} from "locutus/php/var";
import {InputField} from "@/components/form/input";
import api from "@/utils/api";
import {eventManager, Events, StatusEventLevel} from "@/utils/eventManager";
import {updateSessionPermissions} from "@/utils/permissionsManager";
import Api from "@/utils/api";

type State = {
    offline: boolean
}

/**
 * Offline switch.
 */
export default class OfflineBottom extends  React.Component<{}, State> {
    private queueOffline = QueueProcessor(() => {this.forceUpdate()});
    private queueOnline = QueueProcessor(() => {this.forceUpdate()});
    // Username and password
    private onlineUsername:string = smGetSession()?.username || '';
    private onlinePassword:string = '';
    private onlineGoError: boolean = false;
    private onlineGoHelperText: string = '';
    // Is first offline modal open?
    private isFirstOpen = false;
    // Is second offline modal open?
    private isSecondOpen = false;
    // Is online modal open?
    private isOnlineBackOpen = false;
    // Is online working modal open?
    private isOnlineWorkingOpen = false;
    // Subforms to load list, generated by 'form_records_drafts' job.
    private toLoadSubforms: DynFormRecordInterface[] = [];
    // Files to load list, generated by 'form_records_drafts' job.
    private toLoadFiles: any = [];
    // Form record IDs to do not repeat API calls.
    private formRecordFiltered: string[] = [];
    // Form record IDs to do not repeat API calls.
    private formIndexRecordFiltered: string[] = [];
    // Offline mode task list.
    private offlineTasks: Array<loadStateStep> = [
        {key: 'start', label: "Loading...",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return this.queueOffline.defaultTaskResponse();
            }},
        {key: 'parametric-administrative_divisions', label: "Loading administrative divisions",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                let user = smGetSession();
                let countryCode = user?.country?.code || '';
                // We require to remove all divisions loaded not to duplicate.
                return dmInvalidateAllAdministrativeDivisions().then(() => {
                    return dmGetAllAdministrativeDivisions(countryCode, (cnt: number) => {
                        queueContext.setLoaderSublabel(t("loaded @cnt items", {"@cnt": cnt}));
                    });
                });
            }},
        {key: 'parametric-community_services', label: "Loading community services",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetCommunityServices();
            }},
        {key: 'parametric-currencies', label: "Loading currencies",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetCurrencies();
            }},
        {key: 'parametric-default_diameters', label: "Loading default diameters",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetDefaultDiameters();
            }},
        {key: 'parametric-disinfecting_substances', label: "Loading disinfecting substances",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetDisinfectingSubstances();
            }},
        {key: 'parametric-distribution_materials', label: "Loading distribution materials",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetDistributionMaterials();
            }},
        {key: 'parametric-ethnicities', label: "Loading ethnicities",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetEthnicities();
            }},
        {key: 'parametric-functions_carried_out_tap', label: "Loading functions carried out by TAP",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetFunctionsCarriedOutTaps();
            }},
        {key: 'parametric-functions_carried_out_wsp', label: "Loading functions carried out by WSP",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetFunctionsCarriedOutWsps();
            }},
        {key: 'parametric-funder_interventions', label: "Loading funder interventions",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetFunderInterventions();
            }},
        {key: 'parametric-geographical_scope', label: "Loading geographical scopes",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetGeographicalScope();
            }},
        {key: 'parametric-institution_interventions', label: "Loading institution interventions",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetInstitutionInterventions();
            }},
        {key: 'parametric-intervention_status', label: "Loading intervention status",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetInterventionStatuses();
            }},
        {key: 'parametric-storage_infrastructure_materials', label: "Loading storage infrastructure materials",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetMaterials();
            }},
        {key: 'parametric-official_languages', label: "Loading official languages",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetOfficialLanguages();
            }},
        {key: 'parametric-program_interventions', label: "Loading program interventions",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetProgramInterventions();
            }},
        {key: 'parametric-pump_types', label: "Loading pump types",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetPumpTypes();
            }},
        {key: 'parametric-special_components', label: "Loading special components",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetSpecialComponents();
            }},
        {key: 'parametric-technical_assistance_providers', label: "Loading technical assistance providers",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetTechnicalAssistanceProviders();
            }},
        {key: 'parametric-treatment_technology_aera_oxida', label: "Loading treatment technology aeration-oxidation",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetTreatmentTechnologyAerationOxidation();
            }},
        {key: 'parametric-treatment_technology_coag_floccus', label: "Loading treatment technology coagulation-flocculation",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetTreatmentTechnologyCoagFloccus();
            }},
        {key: 'parametric-treatment_technology_desalination', label: "Loading treatment technology desalination",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetTreatmentTechnologyDesalination();
            }},
        {key: 'parametric-treatment_technology_filtration', label: "Loading treatment technology filtration",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetTreatmentTechnologyFiltration();
            }},
        {key: 'parametric-treatment_technology_sedimentation', label: "Loading treatment technology sedimentation",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetTreatmentTechnologySedimentations();
            }},
        {key: 'parametric-type_healthcare_facilities', label: "Loading type of healthcare facilities",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetTypeHealthcareFacilities();
            }},
        {key: 'parametric-type_interventions', label: "Loading type intervention",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetTypeInterventions();
            }},
        {key: 'parametric-type_tap', label: "Loading types of TAP",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetTypeTaps();
            }},
        {key: 'parametric-typology_chlorination_installations', label: "Loading typology chlorination installations",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetTypologyChlorinationInstallations();
            }},
        {key: 'parametric-water_quality_entities', label: "Loading water quality entity",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetWaterQualityEntities();
            }},
        {key: 'parametric-water_quality_intervention_types', label: "Loading water quality intervention types",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetWaterQualityInterventionTypes();
            }},
        {key: 'complete-user-list', label: "Loading users",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                /**
                 * Promise callback to cache user.
                 *
                 * @param list
                 *
                 * @returns {Promise}
                 */
                let callback = (list:any) => {
                    let middlePromise2 = [];
                    for (let i = 0; i < list.length; i++) {
                        let item = list[i];
                        // Loading an image add it to cache the first time.
                        middlePromise2.push(dmLoadImage(item.gravatar));
                    }
                    return Promise.all(middlePromise2);
                };
                let middlePromise = [
                    dmGetSafeUsers().then((list:any) => {return callback(list);}),
                ];
                if (smHasPermission('read doctrine user')) {
                    middlePromise.push(dmGetUsers().then((list:any) => {return callback(list);}));
                }
                return Promise.all(middlePromise);
            }},
        {key: 'countries', label: "Loading countries",
            /**
             * The queue process starting.
             *
             * @returns {Promise}
             */
            action: () => {
                return dmGetCountries()
                    .then((countries:any) => {
                        let middlePromise2 = [];
                        for (let i = 0; i < countries.length; i++) {
                            let imageId = countries[i].flag.id;
                            // Loading an image add it to cache the first time.
                            middlePromise2.push(dmLoadImage(dmGetFileUrl(imageId, false)));
                        }
                        return Promise.all(middlePromise2);
                    });
            }},
        {key: 'form_structures', label: "Loading form structures",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                queueContext.setLoaderSublabel(t("loading list of form types"));
                return dmGetFormTypes()
                    .then((data:any) => {
                        let middlePromise = [];
                        for (const dataKey in data) {
                            let record = data[dataKey];
                            queueContext.setLoaderSublabel(t("loading form type '@type'", {"@type": record.id}));
                            middlePromise.push(dmGetFormStructure(record.id));
                        }

                        return Promise.all(middlePromise);
                    });
            }},
        {key: 'form_empty_records', label: "Loading form empty records",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                queueContext.setLoaderSublabel(t("loading list of form types"));
                return dmGetFormTypes()
                    .then((data:any) => {
                        let middlePromise = [];
                        for (const dataKey in data) {
                            let record = data[dataKey];
                            queueContext.setLoaderSublabel(t("loading form empty record of '@type'", {"@type": record.id}));
                            middlePromise.push(dmGetEmptyFormRecord(record.id));
                        }

                        return Promise.all(middlePromise);
                    });
            }},
        // {key: 'stop', label: "",
        //     /**
        //      * Queue waiting to start.
        //      */
        //     action: () => {}},
        {key: 'invalidate_points', label: "Clean old SIASAR Points",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                return db.invalidateAllFormPoints();
            }},
        {key: 'invalidate_form_records', label: "Clean old form records",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                return db.invalidateAllFormRecords();
            }},
        {key: 'invalidate_form_index_records', label: "Clean old form index records",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                return db.invalidateAllFormIndexRecords();
            }},
        {key: 'invalidate_household_processes', label: "Clean old household processes",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                return db.invalidateAllHouseholdProcesses();
            }},
        {key: 'household_processes', label: "Loading household processes",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                return dmGetHouseholdProcesses(-1, true).then((list:any) => {
                    let middlePromise = [];
                    for (let i = 0; i < list.length; i++) {
                        let item = list[i];
                        queueContext.setLoaderSublabel(t("loading household process '@id'", {"@id": list[i].id}));
                        middlePromise.push(db.addHouseholdProcess(item));
                    }
                    return Promise.all(middlePromise);
                });
            }},
        {key: 'households', label: "Loading households",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                return dmGetUserHouseholds(-1, "", false).then((list:any) => {
                    let middlePromise = [];
                    for (let i = 0; i < list.length; i++) {
                        let item = list[i];
                        // Add form record.
                        queueContext.setLoaderSublabel(t("loading household record '@id'", {"@id": list[i].id}));
                        if (!this.filterFormRecordLoad(list[i].id)) {
                            // Add form record.
                            middlePromise.push(dmGetFormStructure('form.community.household')
                                .then((struct: DynFormStructureInterface) => {
                                    return new Promise((resolve) => {
                                        return db.addFormRecord(item)
                                            .then(() => {
                                                this.processRecordToGetSubformsAndFiles(item, struct);
                                                return resolve([]);
                                            });
                                    });
                                })
                            );
                        }
                    }
                    return Promise.all(middlePromise);
                });
            }},
        {key: 'points_digitizing', label: "Loading SIASAR points in digitizing",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                let middlePromise = [];

                middlePromise.push(
                    dmGetPoints(-1, "digitizing")
                        .then((list) => {
                            let middlePromise2 = [];
                            for (let i = 0; i < list.length; i++) {
                                // Add resumed form record.
                                queueContext.setLoaderSublabel(t("loading SIASAR Point '@id'", {"@id": list[i].id}));
                                middlePromise2.push(db.addPoint(list[i])
                                    .then(() => {
                                        let middlePromise3 = [];
                                        // community: Array [ "01GM8XH6PZAPH3DKN5NZDG1957" ]
                                        for (let j = 0; j < list[i]['community'].length; j++) {
                                            let recordId = list[i]['community'][j];
                                            if (!this.filterFormRecordLoad(recordId)) {
                                                // Add form record.
                                                middlePromise3.push(dmGetFormRecord({formId: 'form.community', id: recordId}, false)
                                                    .then((data: any) => {
                                                        return db.addFormRecord(data)
                                                            .then(() => {
                                                                return dmGetFormStructure('form.community')
                                                                    .then((struct: DynFormStructureInterface) => {
                                                                        this.processRecordToGetSubformsAndFiles(data, struct);
                                                                    });
                                                            });
                                                    })
                                                );
                                            }
                                        }
                                        // wsp: Array [ {…} ]
                                        // 0: Object { id: "01GM8XHWMDPEYKNZWN7XAPPRMD", name: "Junta de Agua de La Flor", meta: [] }
                                        for (let j = 0; j < list[i]['wsp'].length; j++) {
                                            let recordId = list[i]['wsp'][j].id;
                                            if (!this.filterFormRecordLoad(recordId)) {
                                                // Add form record.
                                                middlePromise3.push(dmGetFormRecord({formId: 'form.wsprovider', id: recordId}, false)
                                                    .then((data: any) => {
                                                        return db.addFormRecord(data)
                                                            .then(() => {
                                                                return dmGetFormStructure('form.wsprovider')
                                                                    .then((struct: DynFormStructureInterface) => {
                                                                        this.processRecordToGetSubformsAndFiles(data, struct);
                                                                    });
                                                            });
                                                    })
                                                );
                                            }
                                        }
                                        // wsystem: Array [ {…} ]
                                        // 0: Object { id: "01GM8YB6JY2TZM85CG3XWWSMWM", name: "Sistema de La Flor", meta: [] }
                                        for (let j = 0; j < list[i]['wsystem'].length; j++) {
                                            let recordId = list[i]['wsystem'][j].id;
                                            if (!this.filterFormRecordLoad(recordId)) {
                                                // Add form record.
                                                middlePromise3.push(dmGetFormRecord({formId: 'form.wssystem', id: recordId}, false)
                                                    .then((data: any) => {
                                                        return db.addFormRecord(data)
                                                            .then(() => {
                                                                return dmGetFormStructure('form.wssystem')
                                                                    .then((struct: DynFormStructureInterface) => {
                                                                        this.processRecordToGetSubformsAndFiles(data, struct);
                                                                    });
                                                            });
                                                    })
                                                );
                                            }
                                        }

                                        return Promise.all(middlePromise3);
                                    })
                                );
                                // Add resumed inquiries from point.
                                middlePromise2.push(dmGetPointInquiries(list[i].id)
                                    .then((inquiries: any[]) => {
                                        let middlePromise4 = [];
                                        for (let j = 0; j < inquiries.length; j++) {
                                            if (!this.filterFormIndexRecordLoad(inquiries[j].id)) {
                                                middlePromise4.push(db.addFormIndexRecord(inquiries[j]));
                                            }
                                        }

                                        return Promise.all(middlePromise4);
                                    }));
                            }

                            return Promise.all(middlePromise2);
                        })
                );

                return Promise.all(middlePromise);
            }},
        {key: 'form_records_drafts', label: "Loading draft form records",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                let middlePromise = [];
                let currentUser:User | null = smGetSession();
                const recordTypes = [
                    // Simple inquiries.
                    "form.health.care",
                    "form.school",
                    "form.tap",
                    // Point inquiries.
                    "form.community",
                    "form.wsprovider",
                    "form.wssystem",
                ];

                middlePromise.push(
                    dmGetInquires({page: 1, formType: recordTypes, user_id: currentUser?.id, status: ['draft']})
                        .then((res:any) => {
                            let middlePromise2 = [];
                            for (let i = 0; i < res.length; i++) {
                                // Add resumed form record.
                                queueContext.setLoaderSublabel(t("loading form record '@id'", {"@id": res[i].id}));
                                if (!this.filterFormIndexRecordLoad(res[i].id)) {
                                    middlePromise2.push(db.addFormIndexRecord(res[i]));
                                }
                                if (!this.filterFormRecordLoad(res[i].id)) {
                                    // Add form record.
                                    middlePromise2.push(dmGetFormRecord({formId: res[i].type, id: res[i].id}, false)
                                        .then((data: any) => {
                                            return db.addFormRecord(data)
                                                .then(() => {
                                                    return dmGetFormStructure(res[i].type)
                                                        .then((struct: DynFormStructureInterface) => {
                                                            this.processRecordToGetSubformsAndFiles(data, struct);
                                                        });
                                                });
                                        })
                                    );
                                }
                            }
                            return Promise.all(middlePromise2);
                        })
                );

                return Promise.all(middlePromise);
            }},
        {key: 'form_records_taps', label: "Loading TAP form records",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                let middlePromise = [];
                let currentUser:User | null = smGetSession();
                const recordTypes = [
                    "form.tap",
                ];

                middlePromise.push(
                    dmGetInquires({page: 1, formType: recordTypes})
                        .then((res:any) => {
                            let middlePromise2 = [];
                            for (let i = 0; i < res.length; i++) {
                                // Add resumed form record.
                                queueContext.setLoaderSublabel(t("loading form TAP record '@id'", {"@id": res[i].id}));
                                if (!this.filterFormIndexRecordLoad(res[i].id)) {
                                    middlePromise2.push(db.addFormIndexRecord(res[i]));
                                }
                                if (!this.filterFormRecordLoad(res[i].id)) {
                                    // Add form record.
                                    middlePromise2.push(dmGetFormRecord({formId: res[i].type, id: res[i].id}, false)
                                        .then((data: any) => {
                                            return db.addFormRecord(data)
                                                .then(() => {
                                                    return dmGetFormStructure(res[i].type)
                                                        .then((struct: DynFormStructureInterface) => {
                                                            this.processRecordToGetSubformsAndFiles(data, struct);
                                                        });
                                                });
                                        })
                                    );
                                }
                            }
                            return Promise.all(middlePromise2);
                        })
                );

                return Promise.all(middlePromise);
            }},
        {key: 'form_ref_records', label: "Loading referenced form records",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                return this.processSubForm(queueContext);
            }},
        {key: 'image_files', label: "Loading images",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                let middlePromise = [];
                for (let i = 0; i < this.toLoadFiles.length; i++) {
                    middlePromise.push(dmLoadImage(dmGetFileUrl(this.toLoadFiles[i].file, false)));
                }

                return Promise.all(middlePromise);
            }},
        {key: 'complete', label: "Complete",
            /**
             * The queue is finishing.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext:any) => {
                dmSetOfflineMode(true);
                router.push('/')
                    .then(() => {
                        window.location.reload();
                    });
                return this.queueOffline.defaultTaskResponse();
            }
        },
    ];
    // Offline content to send before online back.
    private zip: any;
    // Online mode task list.
    private onlineTasks: Array<loadStateStep> = [
        {key: 'start', label: "Loading...",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                return this.queueOnline.defaultTaskResponse();
            }},
        {key: 'create_zip', label: "Creating ZIP file with changes",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                const zip = new JSZip();
                return offlineDataRepository.getAllItems()
                    .then((items) => {
                        if (zip) {
                            // Compress changes index to ZIP.
                            zip.file('index.json', JSON.stringify(items));
                            let middlePromise: Promise<any>[] = [];
                            for (let i = 0; i < items.length; i++) {
                                const item: OfflineItemInterface = items[i];
                                if (!item.deleted) {
                                    switch (item.type) {
                                        case offlineDataRepository.OFFLINE_TYPE_FILE:
                                            // Add image files.
                                            middlePromise.push(
                                                dmGetFileName(item.id)
                                                    .then((fileName) => {
                                                        if (empty(fileName)) {
                                                            fileName = "download";
                                                        }
                                                        return dmGetFileContent(item.id)
                                                            .then((b64) => {
                                                                const encodedString = b64.replace(/^data:(.*;)?base64,/, '');
                                                                zip.file('images/'+item.id+'_'+fileName, encodedString, {base64: true});
                                                            })
                                                    })
                                            );
                                            break;
                                        case "form.point":
                                            // Add record json files.
                                            middlePromise.push(
                                                dmGetPoint(item.id)
                                                    .then((record: any) => {
                                                        zip.file('records/'+item.id+'.json', JSON.stringify(record));
                                                    })
                                            );
                                            break;
                                        default:
                                            // Add record json files.
                                            middlePromise.push(
                                                dmGetFormRecord({formId: item.type, id: item.id})
                                                    .then((record: any) => {
                                                        zip.file('records/'+item.id+'.json', JSON.stringify(record));
                                                    })
                                            );
                                            break;
                                    }
                                    if (item.type === offlineDataRepository.OFFLINE_TYPE_FILE) {
                                    } else {
                                    }
                                }
                            }
                            return Promise.all(middlePromise)
                                .then(() => {
                                    return zip.generateAsync({ type: 'blob' })
                                        .then((blobContent) => {
                                            this.zip = blobContent;
                                        });
                                });
                        }
                    });
            }},
        {key: 'download_backup_zip', label: "Please download a data backup, before send to server",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                const user = smGetSession();
                const now = new Date();
                const downloadLink = document.createElement('a');
                downloadLink.href = URL.createObjectURL(this.zip);
                downloadLink.download = `${user?.username}_${now.getFullYear()}-${now.getMonth()+1}-${now.getDate()}.zip`;
                // Start download
                downloadLink.click();
                return this.queueOnline.defaultTaskResponse();
            }},
        {key: 'upload_changes', label: "Sending changes to server",
            /**
             * The queue process starting.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                /*
                curl -X 'POST' \
                  'http://siasar3.localhost/api/v1/form/data/inquiries' \
                  -H 'accept: application/json' \
                  -H 'Content-Type: multipart/form-data' \
                  -F 'file=@AdminlocalHn_2023-4-20.zip;type=application/zip' \
                  -F 'username=a' \
                  -F 'password=a'
                 */
                const data = new FormData();
                const currentHost = localStorage.getItem('current_host');
                const user = smGetSession();
                const now = new Date();
                data.append("username", this.onlineUsername);
                data.append("password", this.onlinePassword);
                data.append("file", this.zip, `${user?.username}_${now.getFullYear()}-${now.getMonth()+1}-${now.getDate()}.zip`);

                let query: string = '';
                let responseStatus = 0;
                if (process.env.NEXT_PUBLIC_SIASAR3_API_DEBUG === '1') {
                    query = "?XDEBUG_SESSION=siasar";
                }

                return fetch(currentHost + api.URL_FORM_INQUIRES + query, {
                    method: "POST",
                    headers: {accept: "application/json"},
                    body: data,
                })
                    .then((response) => {
                        responseStatus = response.status;
                        return response.json();
                    })
                    .then((data) => {
                        if (responseStatus === 201) {
                            // Updated OK.
                            // Disable offline mode.
                            // IMPORTANT: Calling API login clear the current user permissions.
                            return api.login({username: this.onlineUsername, password: this.onlinePassword})
                                .then(() => {
                                    dmSetOfflineMode(false);
                                    updateSessionPermissions();
                                });
                        } else {
                            // Updated fails.
                            // Dispatch status event.
                            eventManager.dispatch(
                                Events.STATUS_ADD,
                                {
                                    level: StatusEventLevel.ERROR,
                                    title: t('Error'),
                                    message: data.message,
                                    isPublic: true,
                                }
                            );
                        }
                    })
                    .catch(error => console.error(error));
            }},
        {key: 'load_country', label: "Loading user country...",
            /**
             * Load user country.
             *
             * @returns {Promise}
             */
            action: () => {
                let user = smGetSession();
                let countryCode = user?.country?.code || '';
                return Api.getCountry(countryCode).then((data: any) => {
                    if (user !== null) {
                        // The user country must be into the user session data.
                        user.country = data;
                    }
                    smSetSession(user);
                });
            },
        },
        {key: 'load_concentration_units', label: "Loading concentration units...",
            /**
             * Load units.
             *
             * @returns {Promise}
             */
            action: () => {
                return Api.getUnits('system.units.concentration').then(data => {
                    return db.addSystemUnits(data[0], "concentration");
                });
            }
        },
        {key: 'load_flow_units', label: "Loading flow units...",
            /**
             * Load units.
             *
             * @returns {Promise}
             */
            action: () => {
                return Api.getUnits('system.units.flow').then(data => {
                    return db.addSystemUnits(data[0], "flow");
                });
            }
        },
        {key: 'load_length_units', label: "Loading length units...",
            /**
             * Load units.
             *
             * @returns {Promise}
             */
            action: () => {
                return Api.getUnits('system.units.length').then(data => {
                    return db.addSystemUnits(data[0], "length");
                });
            }
        },
        {key: 'load_volume_units', label: "Loading volume units...",
            /**
             * Load units.
             *
             * @returns {Promise}
             */
            action: () => {
                return Api.getUnits('system.units.volume').then(data => {
                    return db.addSystemUnits(data[0], "volume");
                });
            }
        },
        {key: 'reload_page', label: "reaload_page",
            /**
             * The queue is finishing.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                return router.push('/')
                    .then(() => {
                        window.location.reload();
                    });
            }
        },
        {key: 'complete', label: "Complete",
            /**
             * The queue is finishing.
             *
             * @param queueContext {any}
             *
             * @returns {Promise}
             */
            action: (queueContext: any) => {
                this.isOnlineWorkingOpen = false;
                return this.queueOnline.defaultTaskResponse();
            }
        },
    ];

    /**
     * Constructor.
     *
     * @param props
     */
    constructor(props: {}) {
        super(props);

        // Copy queue jobs.
        for (let i = 0; i < this.offlineTasks.length; i++) {
            this.queueOffline.add(this.offlineTasks[i]);
        }
        for (let i = 0; i < this.onlineTasks.length; i++) {
            this.queueOnline.add(this.onlineTasks[i]);
        }

        // Init component state.
        this.state = {offline: dmIsOfflineMode()};

        this.processSubForm.bind(this);
        this.processRecordToGetSubformsAndFiles.bind(this);
    }

    /**
     * Filter duplicated record IDs.
     *
     * @param recordId
     *
     * @returns {boolean} True if the ID was filtered, it's duplicated.
     */
    filterFormRecordLoad(recordId: string | undefined) {
        if (typeof recordId === "undefined") {
            return true;
        }

        if (!this.formRecordFiltered.includes(recordId)) {
            this.formRecordFiltered.push(recordId)
            return false;
        }

        return true;
    }

    /**
     * Filter duplicated index record IDs.
     *
     * @param recordId
     *
     * @returns {boolean} True if the ID was filtered, it's duplicated.
     */
    filterFormIndexRecordLoad(recordId: string | undefined) {
        if (typeof recordId === "undefined") {
            return true;
        }

        if (!this.formIndexRecordFiltered.includes(recordId)) {
            this.formIndexRecordFiltered.push(recordId)
            return false;
        }

        return true;
    }

    /**
     * Process each field to get sub-forms and files to load.
     *
     * @param record {any}
     * @param struct {DynFormStructureInterface}
     */
    processRecordToGetSubformsAndFiles(record: any, struct: DynFormStructureInterface) {
        for (const fieldsKey in struct.fields) {
            let field: DynFormStructureFieldInterface = struct.fields[fieldsKey];
            switch (field.type) {
                case 'subform_reference':
                case 'wsprovider_reference':
                case 'wsystem_reference':
                    // Add subform records.
                    //// private toLoadSubforms: DynFormRecordInterface[] = [];
                    // console.log('==>', field.id, record[field.id]);
                    if (field.settings.multivalued) {
                        for (let i = 0; i < record[field.id].length; i++) {
                            if ("" !== record[field.id][i].value) {
                                this.toLoadSubforms.push({formId: record[field.id][i].form, id: record[field.id][i].value});
                            }
                        }
                    } else {
                        if ("" !== record[field.id].value) {
                            this.toLoadSubforms.push({formId: record[field.id].form, id: record[field.id].value});
                        }
                    }
                    break;
                case 'image_reference':
                // case 'file_reference': // Files are not required.
                    // Add files.
                    //// private toLoadFiles: any = [];
                    if (field.settings.multivalued) {
                        for (let i = 0; i < record[field.id].length; i++) {
                            if ("" !== record[field.id][i].value) {
                                this.toLoadFiles.push({file: record[field.id][i].value});
                            }
                        }
                    } else {
                        if ("" !== record[field.id].value) {
                            this.toLoadFiles.push({file: record[field.id].value});
                        }
                    }
                    break;
            }
        }
    }

    /**
     * Load a sub-form referenced, and add discovered sub-forms and files.
     *
     * This method uses the "toLoadSubforms" variable how a queue.
     *
     * @param queueContext {any}
     *
     * @returns {Promise}
     */
    processSubForm(queueContext: any) {
        let item = this.toLoadSubforms.shift();
        if (!item || typeof item === "undefined") {
            return Promise.resolve(true);
        } else {
            if (!this.filterFormRecordLoad(item.id)) {
                queueContext.setLoaderSublabel(t("loading form record '@id'", {"@id": item.id}));
                return dmGetFormRecord({formId: item.formId, id: item.id}, false)
                    .then((data: any) => {
                        return db.addFormRecord(data)
                            .then(() => {
                                if (typeof item !== "undefined") {
                                    return dmGetFormStructure(item.formId)
                                        .then((struct: DynFormStructureInterface) => {
                                            this.processRecordToGetSubformsAndFiles(data, struct);
                                            return this.processSubForm(queueContext);
                                        })
                                        .then((result) => {
                                            // return the Promise returned by the recursive call
                                            return result;
                                        });
                                }
                            });
                    });
            }
        }
    }

    /**
     * Open offline dialog with the info.
     */
    handleFirstOpenModal() {
        this.isFirstOpen = true;
        this.forceUpdate();
    }

    /**
     * Close offline modal with the info.
     */
    handleFirstCloseModal() {
        this.isFirstOpen = false;
        this.forceUpdate()
    }

    /**
     * Open online modal with the info.
     */
    handleFirstOnlineOpenModal() {
        this.isOnlineBackOpen = true;
        this.forceUpdate()
    }

    /**
     * Close online modal with the info.
     */
    handleFirstOnlineCloseModal() {
        this.isOnlineBackOpen = false;
        this.forceUpdate()
    }

    /**
     * Update offline mode status.
     *
     * @param event
     */
    handleOffline(event: any) {
        if (!this.state.offline) {
            this.handleFirstOpenModal();
        } else {
            this.handleFirstOnlineOpenModal();
        }
    }

    /**
     * Display go to offline mode process.
     *
     * @param event
     */
    handleDisconnect(event: any) {
        this.isFirstOpen = false;
        this.isSecondOpen = true;
        this.forceUpdate();
        // Start pre-offline data loading.
        this.queueOffline.init();
    }

    /**
     * Display go to online mode process.
     *
     * @param event
     *
     * @returns {Promise}
     */
    handleConnect(event: any) {
        this.onlineGoError = false;
        this.onlineGoHelperText = '';
        this.forceUpdate();

        let currentHost = localStorage.getItem('current_host');
        return fetch(currentHost+api.URL_LOGIN, {
            headers: {"Content-Type": "application/json", accept: "application/json"},
            method: "POST",
            body: `{"username": "${this.onlineUsername}","password": "${this.onlinePassword}"}`,
        })
            .then((data) => {
                if (data.status !== 200) {
                    this.onlineGoError = true;
                    this.onlineGoHelperText = t('Invalid Credentials');
                    this.forceUpdate();
                } else {
                    // Start process.
                    this.isOnlineBackOpen = false;
                    this.isOnlineWorkingOpen = true;
                    this.forceUpdate();
                    // Start pre-online data loading.
                    this.queueOnline.init();
                }
            })
            .catch((error) => {
                console.warn(error);
            });
    }

    /**
     * Render component.
     *
     * @returns {ReactElement}
     */
    render() {
        if (!smHaveSession() || smIsLoading()) {
            return (<></>);
        }

        let classes: string = 'btn btn-primary btn-red';
        if(this.state.offline) {
            classes = 'btn btn-primary green';
        }
        return (
            <>
                <div className={"offline-action"}>
                    <button type={"button"} className={classes} onClick={this.handleOffline.bind(this)}>{this.state.offline ? t('Go online') : t('Go offline')}</button>
                </div>
                <Modal
                    isOpen={this.isFirstOpen}
                    onRequestClose={this.handleFirstCloseModal.bind(this)}
                    title={t("Go offline")}
                    size={"large"}
                >
                    <p>{t('This process requires loading so much data on your device.')}</p>
                    <p>{t('Do you want to continue?')}</p>

                    <div className="form-actions">
                        <button type="button" className="btn btn-primary green" onClick={this.handleFirstCloseModal.bind(this)}>
                            <FontAwesomeIcon icon={faCancel}/> {t('cancel')}
                        </button>
                        <button type="button" className="btn btn-primary btn-red" onClick={this.handleDisconnect.bind(this)}>
                            <FontAwesomeIcon icon={faUnlink}/> {t('disconnect')}
                        </button>
                    </div>
                </Modal>
                <Modal
                    isOpen={this.isSecondOpen}
                    title={t("Disconnecting")}
                    size={"large"}
                >
                    <div>
                        <LinearProgressWithLabel
                            value={this.queueOffline.getLoaderPercent()}
                            label={this.queueOffline.getLoaderLabel()}
                            sublabel={this.queueOffline.getLoaderSublabel()}
                        />
                    </div>
                </Modal>
                <Modal
                    isOpen={this.isOnlineBackOpen}
                    onRequestClose={this.handleFirstOnlineCloseModal.bind(this)}
                    title={t("Go online")}
                    size={"large"}
                >
                    <p>{t('This process requires sending so much data to the server.')}</p>
                    <p>{t("Before sending the changes to the server, we'll let you download it in ZIP format. Please, download and save it in a safe place before continuing.")}</p>

                    <p>{t('Please, enter your username and password:')}</p>
                    <InputField
                        id={"username"}
                        name={"username"}
                        label={t("Username")}
                        error={this.onlineGoError}
                        value={this.onlineUsername}
                        disabled={true}
                        onChange={(e: SyntheticEvent) => {
                            this.onlineUsername = (e.target as HTMLInputElement).value;
                            // handleChange();
                        }}
                    />

                    <InputField
                        type="password"
                        id={"password"}
                        name={"password"}
                        label={t("Password")}
                        error={this.onlineGoError}
                        helperText={this.onlineGoHelperText}
                        onChange={(e: SyntheticEvent) => {
                            this.onlinePassword = (e.target as HTMLInputElement).value;
                            // handleChange();
                        }}
                    />

                    <p>{t('Do you want to continue?')}</p>

                    <div className="form-actions">
                        <button type="button" className="btn btn-primary btn-red" onClick={this.handleFirstOnlineCloseModal.bind(this)}>
                            <FontAwesomeIcon icon={faCancel}/> {t('cancel')}
                        </button>
                        <button type="button" className="btn btn-primary green" onClick={this.handleConnect.bind(this)}>
                            <FontAwesomeIcon icon={faLink}/> {t('connect')}
                        </button>
                    </div>
                </Modal>
                <Modal
                    isOpen={this.isOnlineWorkingOpen}
                    title={t("Connecting")}
                    size={"large"}
                >
                    <div>
                        <LinearProgressWithLabel
                            value={this.queueOnline.getLoaderPercent()}
                            label={this.queueOnline.getLoaderLabel()}
                            sublabel={this.queueOnline.getLoaderSublabel()}
                        />
                    </div>
                </Modal>
            </>
        );
    }
}
